#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <termios.h>

int main(int argc, char* argv[]) {
	fd_set rfds;
	struct timeval tv;
	int retval;
	struct termios termios_p;
	struct termios termios_o;
	int i;
	int mac;
	int base;
	int ret;
	int delay;

	/* no buffer */
	setvbuf(stdin, 0, _IONBF, 0);

	/* not canonical input */
	tcgetattr(fileno(stdin), &termios_o);
	termios_p = termios_o;
	termios_p.c_lflag &= ~(ICANON | ECHO);
	tcsetattr(fileno(stdin), TCSANOW, &termios_p);

	base = 1;
	mac = argc - 1;

	/* print */
	for(i=0;i<mac;++i) {
		printf("%c - %s\n", (char)('0' + i), argv[base + i]);
	}

	delay = 3;
	while (1) {
		char c;

		/* wait */
		FD_ZERO(&rfds);
		FD_SET(0,&rfds);
		tv.tv_sec = delay;
		tv.tv_usec = 0;

		retval = select(1, &rfds, NULL, NULL, &tv);
		if (!retval) {
			ret = 0;
			break;
		}

		c = getchar();

		if (c>='0' && c<'0' + mac) {
			ret = c - '0' + 1;
			break;
		}

		delay = 8;
	}

	/* restore */
	tcsetattr(fileno(stdin), TCSANOW, &termios_o);

	return ret;
}

