#include <list>
#include <string>
#include <iostream>

#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>

using namespace std;

void process_name(const string& base, const string& name)
{
	string low_name;

	for(unsigned i=0;i<name.length();++i)
		low_name += tolower(name[i]);

	if (low_name != name) {
		string path_from = base + name;
		string path_to = base + low_name;
		if (rename(path_from.c_str(), path_to.c_str()) != 0) {
			cerr << "warning: error renaming " << path_from << endl;
		} else {
			cout << path_from << " " << low_name << endl;
		}
	}
}

void process_dir(const string& base) 
{
	list<string> bag;
	DIR* d;
	struct dirent* dd;

	d = opendir(base.c_str());
	if (!d) {
		cerr << "warning: error opening " << base << endl;
		return;
	}

	while ((dd = readdir(d)) != 0) {
		string name = dd->d_name;
		if (name[0] != '.') {
			string path = base + "/" + name;
			struct stat st;

			if (stat(path.c_str(), &st) == 0) {
				if (S_ISDIR(st.st_mode)) 
					process_dir(path);
				bag.insert(bag.end(), name);
			} else {
				cerr << "warning: error stat " << path << endl;
			}
		}
	}

	closedir(d);

	for(list<string>::iterator i=bag.begin();i!=bag.end();++i) {
		process_name(base + "/", *i);
	}
}

int main(int argc, char* argv[]) 
{
	if (argc!=2) {
		cerr << "Syntax: lowwin DIR" << std::endl;
		exit(EXIT_FAILURE);
	}

	process_dir(argv[1]);

	return EXIT_SUCCESS;
}
